/* Copyright (C) by GFD-Dennou Club, 1999-2000.  All rights reserved. */
/* rngu3.f -- translated by f2c (version 19990503).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* ----------------------------------------------------------------------- */
/*     RANDOM NUMBER GENERATOR (? METHOD BY KUNUTH) */
/* ----------------------------------------------------------------------- */
doublereal rngu3_(integer *iseed)
{
    /* Initialized data */

    static logical lfirst = TRUE_;

    /* System generated locals */
    real ret_val;

    /* Local variables */
    static integer i__, k, inext, ma[55], ii, mj, mk;
    extern /* Subroutine */ int msgdmp_(char *, char *, char *, ftnlen, 
	    ftnlen, ftnlen);
    static integer inextp;

    if (*iseed != 0) {
	mj = 161803398 - abs(*iseed);
	mj %= 1000000000;
	ma[54] = mj;
	mk = 1;
	for (i__ = 1; i__ <= 54; ++i__) {
	    ii = i__ * 21 % 55;
	    ma[ii - 1] = mk;
	    mk = mj - mk;
	    if (mk < 0) {
		mk += 1000000000;
	    }
	    mj = ma[ii - 1];
/* L100: */
	}
	for (k = 1; k <= 4; ++k) {
	    for (i__ = 1; i__ <= 55; ++i__) {
		ma[i__ - 1] -= ma[(i__ + 30) % 55];
		if (ma[i__ - 1] < 0) {
		    ma[i__ - 1] += 1000000000;
		}
/* L200: */
	    }
/* L300: */
	}
	inext = 0;
	inextp = 31;
	*iseed = 0;
	lfirst = FALSE_;
    }
    if (lfirst) {
	msgdmp_("E", "RNGU3", "ISEED MUST BE > 0 FOR 1ST CALL.", (ftnlen)1, (
		ftnlen)5, (ftnlen)31);
    }
    ++inext;
    if (inext == 56) {
	inext = 1;
    }
    ++inextp;
    if (inextp == 56) {
	inextp = 1;
    }
    mj = ma[inext - 1] - ma[inextp - 1];
    if (mj < 0) {
	mj += 1000000000;
    }
    ma[inext - 1] = mj;
    ret_val = mj * 1e-9f;
    return ret_val;
} /* rngu3_ */

